package handler

import (
	"context"
	"time"

	"git.loafle.net/overflow/overflow_gateway_web/conf"
	ogw "git.loafle.net/overflow/overflow_gateway_websocket"
)

type webSocketHandlers struct {
	ogw.SocketHandlers
	ctx context.Context
}

func NewWebSocketHandler(ctx context.Context) ogw.SocketHandler {
	h := &webSocketHandlers{
		ctx: ctx,
	}

	cfg := conf.Config.Handlers["web"]

	h.MaxMessageSize = cfg.Socket.MaxMessageSize
	h.WriteTimeout = cfg.Socket.WriteTimeout * time.Second
	h.ReadTimeout = cfg.Socket.ReadTimeout * time.Second
	h.PongTimeout = cfg.Socket.PongTimeout * time.Second
	h.PingTimeout = cfg.Socket.PingTimeout * time.Second
	h.PingPeriod = cfg.Socket.PingPeriod * time.Second
	h.BinaryMessage = cfg.Socket.BinaryMessage

	ph := newWebJSONRpcHandler(ctx)

	h.Protocol = ph

	return h
}
